﻿using Avalonia.Media;
using CommunityToolkit.Mvvm.ComponentModel;
using CommunityToolkit.Mvvm.Input;
using Leap_Year_kata.BussinessLogic.Services;
using System.Drawing;
using System.Windows.Input;

namespace Leap_Year_kata.Presentation.Avalonia.ViewModels;

public partial class MainViewModel : ViewModelBase
{
    private readonly LeapYearService _leapYearKataService;

    [ObservableProperty]
    private string result;

    [ObservableProperty]
    private int year = 2020;

    [ObservableProperty]
    private IBrush resultTextColor;


    public MainViewModel()
    {
        _leapYearKataService = new LeapYearService();

        CheckLeapYear();
    }

    [RelayCommand]
    public void CheckLeapYear()
    {
        if (_leapYearKataService.IsLeapYear(Year))
        {
            Result = "The year is leap.";
            ResultTextColor = Brushes.Lime;
            return;
        }

        Result = "The year is not leap.";
        ResultTextColor = Brushes.Red;
    }
}
