﻿using Leap_Year_kata.BussinessLogic.Services;

namespace Leap_Year_kata.Tests.Services;

public class LeapYearServiceBasicTests
{
    [Theory]
    [InlineData(2000)]
    [InlineData(4000)]
    public void IsLeapYear_YearDivisibleBy400_ReturnsLeapYear(int leapYear)
    {
        //Arrange
        var leapYearService = new LeapYearService();

        //Act
        var result = leapYearService.IsLeapYear(leapYear);

        //Assert
        Assert.True(result);
    }

    [Theory]
    [InlineData(1700)]
    [InlineData(1800)]
    [InlineData(1900)]
    public void IsLeapYear_YearDivisibleBy100ButNotBy400_ReturnsNotLeapYear(int notLeapYear)
    {
        //Arrange
        var leapYearService = new LeapYearService();

        //Act
        var result = leapYearService.IsLeapYear(notLeapYear);

        //Assert
        Assert.False(result);
    }

    [Theory]
    [InlineData(2008)]
    [InlineData(2012)]
    [InlineData(2016)]
    public void IsLeapYear_YearDivisibleBy4ButNotBy100_ReturnsLeapYear(int leapYear)
    {
        //Arrange
        var leapYearService = new LeapYearService();

        //Act
        var result = leapYearService.IsLeapYear(leapYear);

        //Assert
        Assert.True(result);
    }

    [Theory]
    [InlineData(2017)]
    [InlineData(2018)]
    [InlineData(2019)]
    public void IsLeapYear_YearNotDivisibleBy4_ReturnsNotLeapYear(int notLeapYear)
    {
        //Arrange
        var leapYearService = new LeapYearService();

        //Act
        var result = leapYearService.IsLeapYear(notLeapYear);

        //Assert
        Assert.False(result);
    }
}
